package edu.uwyo.crawl.contentMatcher;

/**
 * An expression representing a character class or its negation.
 * @version 6 March, 2019
 * @author Christopher Stanton
 */
public class BracketExpression extends AbstractExpression {
    ///////////////////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////
    //                  CONSTRUCTORS                   ////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////

    /** Creates a new {@link BracketExpression}. */
    protected BracketExpression() {
        super();
        length.set(0, 1);
    }

    ///////////////////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////
    //              OVERRIDDEN METHODS                 ////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////

    @Override
    public void toString(StringBuilder builder) {
        builder.append("[");
        for (AbstractExpression expression : expressions.get(0)) {
            expression.toString(builder);
        }
        builder.append("]");
        appendNumMatches(builder);
    }

    @Override
    protected void add(AbstractExpression expression, int length) {
        expressions.get(0).add(expression);
    }

    /** Does nothing. */
    @Override
    protected void nextOrGroup() {}
}
