package edu.uwyo.crawl.contentMatcher;

/**
 * An expression representing a single character to be matched.
 * @version 6 March, 2019
 * @author Christopher Stanton
 */
public class CharExpression extends AbstractExpression {
    ///////////////////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////
    //                    FIELDS                       ////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////

    private final String expression;

    ///////////////////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////
    //                  CONSTRUCTORS                   ////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////

    /**
     * Creates a new {@link CharExpression}.
     * @param character the character to be matched
     */
    protected CharExpression(char character) {
        this(String.valueOf(character));
    }

    /**
     * Creates a new {@link CharExpression}.
     * @param characterExpression the String character(s) to be matched
     */
    protected CharExpression(String characterExpression) {
        super();
        this.expression = characterExpression;
        length.set(0, 1);
    }

    ///////////////////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////
    //              OVERRIDDEN METHODS                 ////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////

    @Override
    public void toString(StringBuilder builder) {
        builder.append(expression);
        appendNumMatches(builder);
    }

    /** Does nothing. */
    @Override
    protected void add(AbstractExpression expression, int length) {}

    /** Does nothing. */
    @Override
    protected void nextOrGroup() {}
}
