package edu.uwyo.crawl.contentMatcher;

/**
 * An expression used as a wrapper around a constant value, such as a {@link CharExpression}.
 * @version 6 March, 2019
 * @author Christopher Stanton
 */
public class ConstantExpression extends AbstractExpression {
    ///////////////////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////
    //                  CONSTRUCTORS                   ////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////

    /** Creates a new {@link ConstantExpression}. */
    protected ConstantExpression() {
        super();
    }

    ///////////////////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////
    //              OVERRIDDEN METHODS                 ////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////

    @Override
    public void toString(StringBuilder builder) {
        for (AbstractExpression expression : expressions.get(0)) {
            expression.toString(builder);
        }
        appendNumMatches(builder);
    }

    @Override
    protected void add(AbstractExpression expression, int length) {
        expressions.get(0).add(expression);
        this.length.set(0, this.length.get(0) + length);
    }

    /** Does nothing. */
    @Override
    protected void nextOrGroup() {}
}
