package edu.uwyo.crawl.contentMatcher;

/**
 * An expression representing a capture group.
 * @version 6 March, 2019
 * @author Christopher Stanton
 */
public class GroupExpression extends AbstractExpression {
    ///////////////////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////
    //                  CONSTRUCTORS                   ////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////

    /** Creates a new {@link GroupExpression}. */
    protected GroupExpression() {
        super();
    }

    ///////////////////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////
    //              OVERRIDDEN METHODS                 ////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////

    @Override
    public void toString(StringBuilder builder) {
        builder.append("(");
        for (int i = 0; i < expressions.size(); i++) {
            for (AbstractExpression expression : expressions.get(i)) {
                expression.toString(builder);
            }

            if (i < expressions.size() - 1) {
                builder.append("|");
            }
        }
        builder.append(")");
        appendNumMatches(builder);
    }

    @Override
    protected void add(AbstractExpression expression, int length) {
        expressions.get(currOrGroup).add(expression);
        this.length.set(currOrGroup, this.length.get(currOrGroup) + length);
    }
}
