package edu.uwyo.crawl.ui;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JCheckBoxMenuItem;

import edu.uwyo.Main;
import net.javamon.dev.Resources;

/**
 * A listener for enabling or disabling developer mode.
 * @version 6 March, 2019
 * @author Christopher Stanton
 */
public class DeveloperModeListener implements ActionListener {
    ///////////////////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////
    //                    FIELDS                       ////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////

    private final FrameMain parent;

    ///////////////////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////
    //                  CONSTRUCTORS                   ////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////

    /** Creates a new {@link DeveloperModeListener}. */
    protected DeveloperModeListener(FrameMain parent) {
        this.parent = parent;
    }

    ///////////////////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////
    //              OVERRIDDEN METHODS                 ////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////

    @Override
    public void actionPerformed(ActionEvent e) {
        JCheckBoxMenuItem menu = (JCheckBoxMenuItem) parent.menuDeveloperMode;
        Main.database().setDeveloperMode(menu.isSelected());
        Resources.writeUserSetting("developerMode", menu.isSelected() ? "True" : "False");
        parent.menuDeveloper.setVisible(menu.isSelected());
        parent.main().validate();
    }
}
