package edu.uwyo.crawl.ui;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;

import javax.swing.JFileChooser;

import edu.uwyo.Main;
import net.javamon.dev.Ext;
import net.javamon.dev.utils.RelativeFileChooser;

/**
 * A listener for loading a previous results snapshot file.
 * @version 6 March, 2019
 * @author Christopher Stanton
 */
public class LoadListener implements ActionListener {
    ///////////////////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////
    //                    FIELDS                       ////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////

    private final FrameMain parent;
    private final RelativeFileChooser fileChooser;

    ///////////////////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////
    //                  CONSTRUCTORS                   ////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////

    /** Creates a new {@link LoadListener}. */
    protected LoadListener(FrameMain parent) {
        this.parent = parent;
        fileChooser = RelativeFileChooser.build("mainChooseSnapshotH", Ext.FIND, false);
    }

    ///////////////////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////
    //              OVERRIDDEN METHODS                 ////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////

    @Override
    public void actionPerformed(ActionEvent e) {
        if (Main.currSnapshot() != null) {
            fileChooser.setCurrentDirectory(Main.currSnapshot());
        }

        int choice = fileChooser.showOpenDialog(parent.main().panel);
        if (choice == JFileChooser.APPROVE_OPTION) {
            File toLoad = fileChooser.getSelectedFile();
            if (Main.currSnapshot() != null && Main.currSnapshot().equals(toLoad)) {
                return;
            }

            Main.loadSnapshot(toLoad, null);
        }
    }
}
