package edu.uwyo.crawl.ui.frameClear.panels;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JOptionPane;

import edu.uwyo.Main;
import net.javamon.dev.Console;
import net.javamon.dev.Prompt;
import net.javamon.dev.Resources;

/**
 * A listener for clearing all manual file flags.
 * @version 25 January, 2019
 * @author Christopher Stanton
 */
public class ClearListener implements ActionListener {
    ///////////////////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////
    //                  CONSTRUCTORS                   ////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////

    /** Creates a new {@link ClearListener}. */
    protected ClearListener() {}

    ///////////////////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////
    //              OVERRIDDEN METHODS                 ////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////

    @Override
    public void actionPerformed(ActionEvent e) {
        int choice = Prompt.show(Resources.__("mainClearConfirmH"),
                Resources.__("mainClearConfirmSearchMsg"));

        if (choice == JOptionPane.YES_OPTION) {
            Main.frameMain.hide();
            Console.windowLoad.start(null, null);
            new Thread(new Runnable() {
                @Override
                public void run() {
                    Main.removeAllFlags();

                    Console.windowLoad.stop();
                    Main.frameMain.modify();
                    Main.frameMain.show(Main.currSnapshot());
                }
            }).start();
        }
    }
}
