package edu.uwyo.crawl.ui.frameClear.panels;

import javax.swing.JButton;

import net.javamon.dev.utils.JLabelHTML;
import net.javamon.dev.utils.layout.AbstractPanel;

/**
 * The main panel for {@link edu.uwyo.crawl.ui.frameClear.FrameClear}.
 * @version 8 February, 2019
 * @author Christopher Stanton
 */
public class PanelMain extends AbstractPanel {
    ///////////////////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////
    //                    FIELDS                       ////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////

    public JButton clearConfirm;

    ///////////////////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////
    //                  CONSTRUCTORS                   ////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////

    /** Creates a new {@link PanelMain}. */
    public PanelMain() {
        super();
        setInstructions();
        setClearConfirm();
    }

    ///////////////////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////
    //              OVERRIDDEN METHODS                 ////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////

    @Override
    public void setEnabled(boolean enabled) {
        clearConfirm.setEnabled(enabled);
    }

    @Override
    public void validate() {}

    ///////////////////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////
    //                    METHODS                      ////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////

    /** Sets the instructions label. */
    private void setInstructions() {
        JLabelHTML instructions = createLabel("mainClearInstructions", null);
        layout(WEST, instructions, 5, WEST, panel);
        layout(EAST, instructions, -5, EAST, panel);
        layout(NORTH, instructions, 5, NORTH, panel);
        add(instructions);
    }

    /** Sets the clear confirm button. */
    private void setClearConfirm() {
        clearConfirm = createButton("mainClearSubmit", "mainClearSubmitTT", -1, -1);
        clearConfirm.addActionListener(new ClearListener());
        layout(EAST, clearConfirm, -5, EAST, panel);
        layout(SOUTH, clearConfirm, -5, SOUTH, panel);
        add(clearConfirm);
    }
}
