package edu.uwyo.crawl.ui.frameDeveloper.panels;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;

import javax.swing.JFileChooser;
import javax.swing.JOptionPane;

import edu.uwyo.Main;
import edu.uwyo.crawl.ui.FrameMain;
import net.javamon.dev.Prompt;
import net.javamon.dev.Resources;
import net.javamon.dev.utils.RelativeFileChooser;

/**
 * A listener for changing the current search root.
 * @version 19 March, 2019
 * @author Christopher Stanton
 */
public class ChangeRootListener implements ActionListener {
    ///////////////////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////
    //                    FIELDS                       ////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////

    private final RelativeFileChooser fileChooser;
    private final FrameMain parent;

    ///////////////////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////
    //                  CONSTRUCTORS                   ////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////

    /** Creates a new {@link ChangeRootListener}. */
    protected ChangeRootListener(FrameMain parent) {
        fileChooser = RelativeFileChooser.build("mainChooseRootH", false);
        this.parent = parent;
    }

    ///////////////////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////
    //              OVERRIDDEN METHODS                 ////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////

    @Override
    public void actionPerformed(ActionEvent e) {
        int choice = Prompt.show(Resources.__("mainChangeRootConfirmH"),
                Resources.__("mainChangeRootConfirmMsg"));

        fileChooser.setCurrentDirectory(new File(Main.database().results().resultTree().getFilePath()));
        if (choice == JOptionPane.YES_OPTION
                && fileChooser.showOpenDialog(parent.main().panel) == JFileChooser.APPROVE_OPTION) {
            File newRoot = fileChooser.getSelectedFile();

            Main.database().results().resultTree().forceRoot(null, newRoot.getAbsolutePath());
            if (parent.main().list.tree.redraw()) {
                parent.modify();
            }
        }
    }
}
