package edu.uwyo.crawl.ui.frameExclude.panels;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import net.javamon.dev.Resources;

/**
 * A listener used for selecting common file extensions to be excluded.
 * @version 25 March, 2019
 * @author Christopher Stanton
 */
public class ExcludeNonTextListener implements ActionListener {
    ///////////////////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////
    //                    FIELDS                       ////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////

    private final PanelExtensions parent;

    ///////////////////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////
    //                  CONSTRUCTORS                   ////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////

    /** Creates a new {@link ExcludeNonTextListener}. */
    protected ExcludeNonTextListener(PanelExtensions parent) {
        this.parent = parent;
    }

    ///////////////////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////
    //              OVERRIDDEN METHODS                 ////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////

    @Override
    public void actionPerformed(ActionEvent e) {
        String text = Resources.readSetting("excludeNonText");
        if (text != null) {
            parent.fileTypes.setText(text);
        }
    }
}
