package edu.uwyo.crawl.ui.frameExclude.panels;

import edu.uwyo.crawl.RestorableView;
import net.javamon.dev.utils.layout.AbstractPanel;

/**
 * The main panel for {@link edu.uwyo.crawl.ui.frameExclude.FrameExclude}.
 * @version 15 February, 2019
 * @author Christopher Stanton
 */
public class PanelMain extends AbstractPanel implements RestorableView {
    ///////////////////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////
    //                    FIELDS                       ////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////

    public PanelRegex regex;
    public PanelFiles files;
    public PanelExtensions extensions;

    ///////////////////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////
    //                  CONSTRUCTORS                   ////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////

    /** Creates a new {@link PanelMain}. */
    public PanelMain() {
        super();
        setRegex();
        setExtensions();
        setFiles();
    }

    ///////////////////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////
    //              OVERRIDDEN METHODS                 ////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////

    @Override
    public void setEnabled(boolean enabled) {
        regex.setEnabled(enabled);
        files.setEnabled(enabled);
        extensions.setEnabled(enabled);
    }

    @Override
    public void validate() {
        regex.validate();
        files.validate();
        extensions.validate();
    }

    @Override
    public void restoreView() {
        regex.restoreView();
        files.restoreView();
        extensions.restoreView();
    }

    @Override
    public void saveView() {
        regex.saveView();
        files.saveView();
        extensions.saveView();
    }

    ///////////////////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////
    //                    METHODS                      ////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////

    /** Sets the regex panel. */
    private void setRegex() {
        regex = new PanelRegex();
        layout(WEST, regex.panel, 5, WEST, panel);
        layout(NORTH, regex.panel, 5, NORTH, panel);
        layout(EAST, regex.panel, -5, EAST, panel);
        add(regex.panel);
    }

    /** Sets the extensions panel. */
    private void setExtensions() {
        extensions = new PanelExtensions();
        layout(WEST, extensions.panel, 5, WEST, panel);
        layout(NORTH, extensions.panel, 5, SOUTH, regex.panel);
        layout(EAST, extensions.panel, -5, EAST, panel);
        add(extensions.panel);
    }

    /** Sets the files panel. */
    private void setFiles() {
        files = new PanelFiles();
        layoutFill(files.panel, 5, extensions.panel, panel, panel, panel);
        add(files.panel);
    }
}
