package edu.uwyo.crawl.ui.frameJoin.panels;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;

import javax.swing.JFileChooser;

import net.javamon.dev.Ext;
import net.javamon.dev.Resources;
import net.javamon.dev.utils.RelativeFileChooser;

/**
 * A listener for adding a new file to be joined.
 * @version 28 March, 2019
 * @author Christopher Stanton
 */
public class AddListener implements ActionListener {
    ///////////////////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////
    //                    FIELDS                       ////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////

    private final PanelMain parent;
    private final RelativeFileChooser fileChooser;

    ///////////////////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////
    //                  CONSTRUCTORS                   ////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////

    /** Creates a new {@link AddListener}. */
    protected AddListener(PanelMain parent) {
        this.parent = parent;
        fileChooser = RelativeFileChooser.build("mainJoinAddH", -1, JFileChooser.FILES_ONLY,
                Resources.fileType(Ext.FIND), true);
    }

    ///////////////////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////
    //              OVERRIDDEN METHODS                 ////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////

    @Override
    public void actionPerformed(ActionEvent e) {
        int choice = fileChooser.showOpenDialog(parent.panel);

        if (choice == JFileChooser.APPROVE_OPTION) {
            File[] files = fileChooser.getSelectedFiles();
            for (int i = 0; i < files.length; i++) {
                parent.list.list.model().addElement(files[i].getAbsolutePath());
            }
            parent.validate();
        }
    }
}
