package edu.uwyo.crawl.ui.frameJoin.panels;

import edu.uwyo.crawl.ui.frameFlags.panels.PanelFlag;
import edu.uwyo.crawl.ui.panels.PanelFiles;
import net.javamon.dev.Resources;
import net.javamon.dev.utils.HTML;
import net.javamon.dev.utils.layout.AbstractPanel;

/**
 * A panel representing the file flags to include in the join operation.
 * @version 28 March, 2019
 * @author Christopher Stanton
 */
public class PanelFlags extends AbstractPanel {
    ///////////////////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////
    //                    FIELDS                       ////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////

    public PanelFlag[] flag;

    private final boolean[] flags;

    ///////////////////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////
    //                  CONSTRUCTORS                   ////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////

    /** Creates a new {@link PanelFlags}. */
    public PanelFlags() {
        super("mainJoinFlagsBdr", 260, 210);

        layoutGrid.start(1, 0, 5, panel, panel);
        setFlags();
        layoutGrid.end();

        flags = new boolean[flag.length];
    }

    ///////////////////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////
    //              OVERRIDDEN METHODS                 ////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////

    @Override
    public void setEnabled(boolean enabled) {
        for (int i = 0; i < flag.length; i++) {
            flag[i].setEnabled(enabled);
        }
    }

    @Override
    public void validate() {
        for (int i = 0; i < flag.length; i++) {
            flag[i].validate();
        }
    }

    ///////////////////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////
    //                    METHODS                      ////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////

    /** @return an array of boolean enabled and disabled file flags */
    protected boolean[] getFlags() {
        for (int i = 0; i < flag.length; i++) {
            flags[i] = flag[i].enabled.isSelected();
        }
        return flags;
    }

    /** Sets the flag panels. */
    private void setFlags() {
        flag = new PanelFlag[PanelFiles.getNumFlags()];
        for (int i = 0; i < flag.length; i++) {
            flag[i] = new PanelFlag(null, i);
            flag[i].setPreferredSize(240, flag[i].getPreferredSize().height);
            flag[i].enabled.setToolTipText(HTML.wrap(Resources.__("mainJoinFlagsTT")));
            flag[i].label.setToolTipText(HTML.wrap(Resources.__("mainJoinFlagsTT")));
            layoutGrid.place(flag[i].panel);
        }
    }
}
