package edu.uwyo.crawl.ui.frameJoin.panels;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

/**
 * A listener for removing the current file from the join list.
 * @version 28 March, 2019
 * @author Christopher Stanton
 */
public class RemoveListener implements ActionListener {
    ///////////////////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////
    //                    FIELDS                       ////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////

    private final PanelMain parent;

    ///////////////////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////
    //                  CONSTRUCTORS                   ////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////

    /** Creates a new {@link RemoveListener}. */
    protected RemoveListener(PanelMain parent) {
        this.parent = parent;
    }

    ///////////////////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////
    //              OVERRIDDEN METHODS                 ////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////

    @Override
    public void actionPerformed(ActionEvent e) {
        final int toRemove = parent.list.list.list().getSelectedIndex();
        if (toRemove == parent.list.getMasterIndex()) {
            parent.list.removeMasterIndex();
        }
        parent.list.list.model().remove(toRemove);
        parent.validate();
    }
}
