package edu.uwyo.crawl.ui.panels;

import edu.uwyo.crawl.RestorableView;
import net.javamon.dev.utils.layout.AbstractPanel;

/**
 * The options panel for determining file time stamps.
 * @version 8 February, 2019
 * @author Christopher Stanton
 */
public class PanelOptionsTime extends AbstractPanel implements RestorableView {
    ///////////////////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////
    //                    FIELDS                       ////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////

    public PanelTime[] modes;

    ///////////////////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////
    //                  CONSTRUCTORS                   ////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////

    /** Creates a new {@link PanelOptionsTime} */
    public PanelOptionsTime(PanelMain parent) {
        super(230, 243);
        layoutGrid.start(1, 0, 0, panel, panel);
        setModes(parent);
        layoutGrid.end();
    }

    ///////////////////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////
    //              OVERRIDDEN METHODS                 ////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////

    @Override
    public void setEnabled(boolean enabled) {
        for (int i = 0; i < modes.length; i++) {
            modes[i].setEnabled(enabled);
        }
    }

    @Override
    public void validate() {
        for (int i = 0; i < modes.length; i++) {
            modes[i].validate();
        }
    }

    @Override
    public void restoreView() {
        for (int i = 0; i < modes.length; i++) {
            modes[i].restoreView();
        }
    }

    @Override
    public void saveView() {
        for (int i = 0; i < modes.length; i++) {
            modes[i].saveView();
        }
    }

    ///////////////////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////
    //                    METHODS                      ////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////

    /** Sets the mode panels. */
    private void setModes(PanelMain parent) {
        modes = new PanelTime[PanelTime.NUM_MODES];
        for (int i = 0; i < PanelTime.NUM_MODES; i++) {
            modes[i] = new PanelTime(parent, i);
            layoutGrid.place(modes[i].panel);
        }
    }
}
