package edu.uwyo.crawl.ui.popup;

import java.awt.datatransfer.StringSelection;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Paths;

import net.javamon.dev.ClipboardTools;

/**
 * A listener for copying a file's contents.
 * @version 25 February, 2019
 * @author Christopher Stanton
 */
public class CopyContentsListener implements ActionListener {
    ///////////////////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////
    //                    FIELDS                       ////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////

    private final FilePopupMenu menu;

    ///////////////////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////
    //                  CONSTRUCTORS                   ////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////

    /**
     * Creates a new {@link CopyContentsListener}.
     * @param menu the parent {@link FilePopupMenu}
     */
    protected CopyContentsListener(FilePopupMenu menu) {
        this.menu = menu;
    }

    ///////////////////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////
    //              OVERRIDDEN METHODS                 ////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////

    @Override
    public void actionPerformed(ActionEvent e) {
        if (menu.currNodes().length > 1 || menu.currNodes()[0].getFilePath() == null) { return; }

        String file = null;
        try {
            byte[] bytes = Files.readAllBytes(Paths.get(menu.currNodes()[0].getFilePath()));
            file = new String(bytes, "UTF-8").replace("\0", "");
        } catch (IOException e1) {
            return;
        }

        ClipboardTools.store(new StringSelection(file));
    }
}
