package edu.uwyo.crawl.ui.popup;

import java.awt.datatransfer.StringSelection;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;

import net.javamon.dev.ClipboardTools;

/**
 * A listener for copying a file's entire path.
 * @version 25 February, 2019
 * @author Christopher Stanton
 */
public class CopyPathListener implements ActionListener {
    ///////////////////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////
    //                    FIELDS                       ////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////

    private final FilePopupMenu menu;

    ///////////////////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////
    //                  CONSTRUCTORS                   ////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////

    /**
     * Creates a new {@link CopyPathListener}.
     * @param menu the parent {@link FilePopupMenu}
     */
    protected CopyPathListener(FilePopupMenu menu) {
        this.menu = menu;
    }

    ///////////////////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////
    //              OVERRIDDEN METHODS                 ////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////

    @Override
    public void actionPerformed(ActionEvent e) {
        StringBuilder builder = new StringBuilder();
        for (int i = 0; i < menu.currNodes().length; i++) {
            String nodePath = menu.currNodes()[i].getFilePath();
            File f = menu.currNodes()[i].getNodePathAsFile(menu.isFlat());

            if (nodePath != null) {
                builder.append(new File(nodePath).getAbsolutePath().replace("\n", ""));
            } else if (f != null) {
                builder.append(f.getAbsolutePath().replace("\n", ""));
            } else {
                continue;
            }

            if (i < menu.currNodes().length - 1) {
                builder.append(" ");
            }

        }
        ClipboardTools.store(new StringSelection(builder.toString()));
    }
}
