package edu.uwyo.crawl.ui.popup;

import java.awt.Desktop;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;

import edu.uwyo.crawl.ui.tree.AbstractFileNode;

/**
 * A listener for opening a file.
 * @version 25 February, 2019
 * @author Christopher Stanton
 */
public class OpenFileListener implements ActionListener {
    ///////////////////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////
    //                    FIELDS                       ////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////

    private final FilePopupMenu menu;

    ///////////////////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////
    //                  CONSTRUCTORS                   ////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////

    /**
     * Creates a new {@link OpenFileListener}.
     * @param menu the parent {@link FilePopupMenu}
     */
    protected OpenFileListener(FilePopupMenu menu) {
        this.menu = menu;
    }

    ///////////////////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////
    //              OVERRIDDEN METHODS                 ////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////

    @Override
    public void actionPerformed(ActionEvent e) {
        openFiles(menu.currNodes());
    }

    ///////////////////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////
    //                    METHODS                      ////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////

    /**
     * Opens the files described by the given node(s).
     * @param nodes the array of {@link AbstractFileNode} representing files to be opened
     */
    public static void openFiles(AbstractFileNode[] nodes) {
        try {
            for (int i = 0; i < nodes.length; i++) {
                String nodePath = nodes[i].getFilePath();
                if (nodePath != null) {
                    Desktop.getDesktop().open(new File(nodePath));
                }
            }
        } catch (Exception e1) {}
    }
}
