package edu.uwyo.crawl.ui.popup;

import java.awt.Desktop;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;

/**
 * A listener for opening a file's location.
 * @version 25 February, 2019
 * @author Christopher Stanton
 */
public class OpenFileLocationListener implements ActionListener {
    ///////////////////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////
    //                    FIELDS                       ////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////

    private final FilePopupMenu menu;

    ///////////////////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////
    //                  CONSTRUCTORS                   ////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////

    /**
     * Creates a new {@link OpenFileLocationListener}.
     * @param menu the parent {@link FilePopupMenu}
     */
    protected OpenFileLocationListener(FilePopupMenu menu) {
        this.menu = menu;
    }

    ///////////////////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////
    //              OVERRIDDEN METHODS                 ////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////

    @Override
    public void actionPerformed(ActionEvent e) {
        try {
            for (int i = 0; i < menu.currNodes().length; i++) {
                String nodePath = menu.currNodes()[i].getFilePath();
                File f = menu.currNodes()[i].getNodePathAsFile(menu.isFlat());

                if (nodePath != null) {
                    Desktop.getDesktop().open(new File(nodePath).getParentFile());
                } else if (f != null) {
                    Desktop.getDesktop().open(f);
                }
            }
        } catch (Exception e1) {}
    }
}
