package edu.uwyo.crawl.ui.tree;

import java.awt.Color;

import javax.swing.Icon;
import javax.swing.JComponent;
import javax.swing.JLabel;

/**
 * A renderer for entries that uses the default {@link FileNodeToolTipTree} appearance.
 * Should be used if a custom {@link AbstractFileEntryRenderer} is not provided.
 * @version 21 February, 2019
 * @author Christopher Stanton
 */
public class DefaultFileEntryRenderer extends AbstractFileEntryRenderer {
    ///////////////////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////
    //                    FIELDS                       ////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////

    private JLabel label;

    ///////////////////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////
    //                  CONSTRUCTORS                   ////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////

    /** Creates a new {@link DefaultFileEntryRenderer}. */
    protected DefaultFileEntryRenderer() {
        super();
        label = new JLabel();
    }

    ///////////////////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////
    //              OVERRIDDEN METHODS                 ////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////

    @Override
    protected JComponent set(Icon icon, int iconTextGap, String entry, Color background,
            Color treeBackground, boolean selected, Color selectionDefault) {
        label.setIcon(icon);
        label.setIconTextGap(iconTextGap);
        label.setText(entry);
        label.setOpaque(background != null || selected);
        if (background != null) {
            label.setBackground(selected ? background.darker() : background);
        } else {
            label.setBackground(selected ? selectionDefault : treeBackground);
        }
        return label;
    }
}
